package sw1.filesimilarity;

import java.io.File;
import java.io.IOException;
import java.util.List;

public class FileIndex {
	private static final String ERROR = "[ERROR] ";

	// TODO fields

	/**
	 * Given a path to a folder, reads all the files in it and indexes them
	 */
	public void index(String folderPath) {
		// first, clear the previous contents of the index
		clearPreviousIndex();
		File folder = new File(folderPath);
		File[] listFiles = folder.listFiles();
		for (File file : listFiles) {
			// for every file in the folder
			if (file.isFile()) {
				String path = file.getAbsolutePath();
				System.out.println("Indexing " + path);
				try {
					// add to the index if read is successful
					addFileToIndex(file);
				} catch (IOException e) {
					System.out.println(ERROR + "failed to read from "
							+ path);
				}
			}
		}
	}

	/**
	 * Adds the input file to the index
	 */
	public void addFileToIndex(File file) throws IOException {
		List<String> tokens = FileUtils.readAllTokens(file);
		String path = file.getAbsolutePath();
		if (tokens.isEmpty()) {
			System.out.println(ERROR + "ignoring empty file " + path);
			return;
		}

		// TODO complete
	}

	/**
	 * Called at the beginning of index() in order to clear the fields from
	 * previously indexed files. After calling it the index contains no files.
	 */
	public void clearPreviousIndex() {
		// TODO complete
	}

	/**
	 * Given indexed input files, compute their cosine similarity based on their
	 * indexed tokens
	 */
	public double getCosineSimilarity(File file1, File file2) {
		if (!verifyFile(file1) || !verifyFile(file2)) {
			return Double.NaN;
		}
		// TODO complete
	}

	/**
	 * Given an indexed input file, returns a list of the other indexed files,
	 * ordered from the highest to lowest cosine similarity to the input file.
	 * The output list should not contain the input file itself.
	 */
	public List<File> getFilesBySimilarity(File file) {
		if (!verifyFile(file)) {
			return null;
		}

		// TODO complete
	}

	/**
	 * returns true iff the input file is currently indexed. Otherwise, prints
	 * an error message.
	 */
	public boolean verifyFile(File file) {
		// TODO complete
	}

	/**
	 * @return the number of files currently indexed.
	 */
	public int getNumIndexedFiles() {
		// TODO complete
	}

}
